# This file is generated by SciPy's build process
# It contains system_info results at the time of building this package.
from enum import Enum

__all__ = ["show"]
_built_with_meson = True


class DisplayModes(Enum):
    stdout = "stdout"
    dicts = "dicts"


def _cleanup(d):
    """
    Removes empty values in a `dict` recursively
    This ensures we remove values that Meson could not provide to CONFIG
    """
    if isinstance(d, dict):
        return { k: _cleanup(v) for k, v in d.items() if v != '' and _cleanup(v) != '' }
    else:
        return d


CONFIG = _cleanup(
    {
        "Compilers": {
            "c": {
                "name": "clang",
                "linker": r"ld64",
                "version": "15.0.0",
                "commands": r"cc",
                "args": r"-fPIC, -arch, arm64, -D__FFTW, -I., -I/Users/runner/work/qepy/qepy/build/temp.macosx-11.0-arm64-cpython-311/q-e//include, -std=c99",
                "linker args": r"-headerpad_max_install_names, -Wl,-rpath,$ORIGIN/:$ORIGIN/qepy",
            },
            "cython": {
                "name": r"",
                "linker": r"",
                "version": r"",
                "commands": r"",
                "args": r"",
                "linker args": r"",
            },
            "c++": {
                "name": "",
                "linker": r"",
                "version": "",
                "commands": r"",
                "args": r"",
                "linker args": r"",
            },
            "fortran": {
                "name": "gcc",
                "linker": r"ld64",
                "version": "14.2.0",
                "commands": r"gfortran",
                "args": r"-fPIC, -fallow-argument-mismatch, -ff2c, -fno-second-underscore, -cpp, -D__FFTW, -I/Users/runner/work/qepy/qepy/build/temp.macosx-11.0-arm64-cpython-311/q-e//external/devxlib/src, -I., -I/Users/runner/work/qepy/qepy/build/temp.macosx-11.0-arm64-cpython-311/q-e//include, -I., -I/Users/runner/work/qepy/qepy/build/temp.macosx-11.0-arm64-cpython-311/q-e/UtilXlib",
                "linker args": r"-headerpad_max_install_names, -Wl,-rpath,$ORIGIN/:$ORIGIN/qepy",
            },
            "pythran": {
                "version": r"",
                "include directory": r""
            },
        },
        "Machine Information": {
            "host": {
                "cpu": r"aarch64",
                "family": r"aarch64",
                "endian": r"little",
                "system": r"darwin",
            },
            "build": {
                "cpu": r"aarch64",
                "family": r"aarch64",
                "endian": r"little",
                "system": r"darwin",
            },
            "cross-compiled": bool("False".lower().replace('false', '')),
        },
        "Build Dependencies": {
            "blas": {
                "name": "",
                "found": bool("".lower().replace('false', '')),
                "version": "",
                "detection method": "",
                "include directory": r"",
                "lib directory": r"",
                "openblas configuration": r"",
                "pc file directory": r"",
            },
            "lapack": {
                "name": "",
                "found": bool("".lower().replace('false', '')),
                "version": "",
                "detection method": "",
                "include directory": r"",
                "lib directory": r"",
                "openblas configuration": r"",
                "pc file directory": r"",
            },
            "pybind11": {
                "name": "",
                "version": "",
                "detection method": "",
                "include directory": r"",
            },
        },
        "Python Information": {
            "path": r"/private/var/folders/g6/rgtlsw6n123b0gt5483s5_cm0000gn/T/cibw-run-9bqydaiy/cp311-macosx_arm64/build/venv/bin/python",
            "version": "3.11",
        },
        "QE": {
            "path": r"/Users/runner/work/qepy/qepy/build/temp.macosx-11.0-arm64-cpython-311/q-e",
            "link": r"-L/Users/runner/work/qepy/qepy/build/temp.macosx-11.0-arm64-cpython-311/q-e//external/devxlib/src, -ldevXlib, -llapack, -lblas",
            "conf": r"--host=host",
        },
    }
)


def _check_pyyaml():
    import yaml

    return yaml


def show(mode=DisplayModes.stdout.value):
    """
    Show libraries and system information on which SciPy was built
    and is being used

    Parameters
    ----------
    mode : {`'stdout'`, `'dicts'`}, optional.
        Indicates how to display the config information.
        `'stdout'` prints to console, `'dicts'` returns a dictionary
        of the configuration.

    Returns
    -------
    out : {`dict`, `None`}
        If mode is `'dicts'`, a dict is returned, else None

    Notes
    -----
    1. The `'stdout'` mode will give more readable
       output if ``pyyaml`` is installed

    """
    if mode == DisplayModes.stdout.value:
        try:  # Non-standard library, check import
            yaml = _check_pyyaml()

            print(yaml.dump(CONFIG))
        except ModuleNotFoundError:
            import warnings
            import json

            warnings.warn("Install `pyyaml` for better output", stacklevel=1)
            print(json.dumps(CONFIG, indent=2))
    elif mode == DisplayModes.dicts.value:
        return CONFIG
    else:
        raise AttributeError(
            f"Invalid `mode`, use one of: {', '.join([e.value for e in DisplayModes])}"
        )
